\documentclass[border=5pt]{standalone}
\usepackage{tikz}
\usetikzlibrary{calc,intersections}

\newcommand\DrawBlock[3]{
	\ifx#1b\relax
	\path[draw]
	(lm\the\numexpr#2-1\relax) -- ++(0,0,#3) coordinate (blocklf)
	(bm\the\numexpr#2-1\relax) -- ++(0,0,#3) coordinate (blocklb)
	(lm#2) -- ++(0,0,#3) coordinate (blockrf)
	(bm#2) -- ++(0,0,#3) coordinate (blockrb);
	\filldraw[fill=white,draw=black]
	(lm\the\numexpr#2-1\relax) -- (blocklf) -- (blocklb) -- (blockrb) -- (blockrf) -- (lm#2);
	\else
	\ifx#1f\relax
	\path[draw]
	(fm\the\numexpr#2-1\relax) -- ++(0,0,#3) coordinate (blocklf)
	(lm\the\numexpr#2-1\relax) -- ++(0,0,#3) coordinate (blocklb)
	(fm#2) -- ++(0,0,#3) coordinate (blockrf)
	(lm#2) -- ++(0,0,#3) coordinate (blockrb);
	\filldraw[fill=white,draw=black]
	(fm\the\numexpr#2-1\relax) -- (blocklf) -- (blocklb) -- (blockrb) -- (blockrf) -- (fm#2);
	\fi
	\fi
	\draw (blocklf) -- (blockrf);
}

\begin{document}
	\begin{tikzpicture}[y={(0:1cm)},x={(225:0.86cm)}, z={(90:1cm)}]

	% coordinates for the lower grid
	\path
	(1,3,0) coordinate (bm0) --
	(4,3,0) coordinate (fm0) coordinate[midway] (lm0) --
	(4,8,0) coordinate[pos=0.25] (fm1) coordinate[midway] (fm2) coordinate[pos=0.75] (fm3) coordinate (fm4) --
	(1,8,0) coordinate (bm4) coordinate[midway] (lm4)--
	(bm0) coordinate[pos=0.25] (bm3) coordinate[midway] (bm2) coordinate[pos=0.75] (bm1);
	\draw[dashed]
	(lm0) --
	(lm4) coordinate[pos=0.25] (lm1) coordinate[midway] (lm2) coordinate[pos=0.75] (lm3);

	% the blocks
	\DrawBlock{b}{1}{3.8}
	\DrawBlock{b}{2}{4.1}
	\DrawBlock{b}{3}{4.7}
	\DrawBlock{b}{4}{5.4}
	\DrawBlock{f}{1}{3.7}
	\DrawBlock{f}{2}{4.0}
	\DrawBlock{f}{3}{4.5}
	\DrawBlock{f}{4}{5.2}

	\foreach \Point/\Height in {lm1/4.1,lm2/4.5,lm3/5.2}
	\draw[ultra thin,dashed,opacity=0.2] (\Point) -- ++(0,0,\Height);

	% the lower grid
	\foreach \x in {1,2,3}
	\draw[dashed] (fm\x) -- (bm\x);
	\draw[dashed] (fm0) -- (bm0) -- (bm4);
	\draw (fm0) -- (fm4) -- (bm4);
	\draw[dashed] (lm0) -- (lm4);

	% coordinates for the surface
	\coordinate (curvefm0) at ( $ (fm0) + (0,0,4) $ );
	\coordinate (curvebm0) at ( $ (bm0) + (0,0,4) $ );
	\coordinate (curvebm4) at ( $ (bm4) + (0,0,6) $ );
	\coordinate (curvefm4) at ( $ (fm4) + (0,0,5.7) $ );

	% the surface
	\filldraw[ultra thick,fill=gray!25,fill opacity=0.2]
	(curvefm0) to[out=-30,in=210]
	(curvefm4) to[out=-4,in=260]
	(curvebm4) to[out=215,in=330]
	(curvebm0) to[out=240,in=-20]
	(curvefm0);

	% lines from grid to surface
	\draw[very thick,name path=leftline] (curvefm0) -- (fm0);
	\draw[very thick] (curvefm4) -- (fm4);
	\draw[very thick,name path=rightline] (curvebm4) -- (bm4);
	\draw[very thick,dashed] (curvebm0) -- (bm0);

	% coordinate system
	\coordinate (O) at (1,3,0);
	\draw[-latex] (O) -- +(5,0,0) node[above left] {$y$};
	\draw[-latex] (O) -- +(0,6,0) node[above left] {$x$};
	\draw[-latex] (O) -- +(0,0,5) node[above left] {$z$};
%	\path[name path=yaxis] (O) -- +(0,6,0) coordinate (yaxisfinal) node[above] {$y$};
%	\draw[-latex] (O) -- +(0,0,5) node[left] {$z$};
%%	\path[name intersections={of=yaxis and leftline,by={yaxis1}}];
%	\path[name intersections={of=yaxis and rightline,by={yaxis2}}];
%%	\draw (O) -- (yaxis1);
%%	\draw[densely dashed,opacity=0.1] (yaxis1) -- (yaxis2);
%	\draw[-latex] (yaxis2) -- (yaxisfinal);

	% for debugging
	%\foreach \Name in {bm0,fm0,lm0,fm1,fm2,fm3,fm4,bm4,lm4,bm1,bm2,bm3,lm1,lm2,lm3,%
	%curvefm0,curvebm0,curvebm4,curvefm4}
	%  \node at (\Name) {\Name};
	\end{tikzpicture}

\end{document}
